<template>
  <!-- <router-link :class="linkClass" :to="url" >{{text}}</router-link> -->
  <a :class="linkClass" href="url" @click.prevent="setLocation(url)">{{text}}</a>
</template>
<script>
import { mapMutations } from "vuex";
export default {
  props: ["url", "text", "id"],

  created() {
    window.addEventListener("scroll", this.isInViewport);
  },

  beforeDestroy() {
    window.removeEventListener("scroll", this.isInViewport);
  },

  data() {
    return {
      linkClass: "link"
    };
  },

  methods: {
    ...mapMutations(["setLocation"]),
    isInViewport() {
      if (!this.id) {
        this.linkClass = "link";
        return;
      }
      const element = document.getElementById("categ-" + this.id);
      if (!rect) return;
      const rect = element.getBoundingClientRect();
      const html = document.documentElement;
      if (
        rect.top <= (window.innerHeight || html.clientHeight) &&
        rect.bottom >= 150
      ) {
        this.linkClass = "link-active";
      } else {
        this.linkClass = "link";
      }
    }
  }
};
</script>
<style scoped>
.link {
  text-align: center;
  display: inline-block;
  padding: 10px;
  color: #777;
}
.link-active {
  text-align: center;
  display: inline-block;
  padding: 10px;
  color: #f0712c;
}
.link:hover {
  color: black;
}
</style>

